'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var lr = require('@lezer/lr');
var language = require('@codemirror/language');
var highlight = require('@lezer/highlight');

// This file was generated by lezer-generator. You probably shouldn't edit it.
const intersecop = 34;

/* Hand-written tokenizers for excel formula tokens that can't be
  expressed by lezer's built-in tokenizer (or are harder to express). */
const openParen = 40, closeParen = 41, backSlash = 92, underscore = 95, dot = 46, questionMark = 63, euroSign = 8364, isSpace = (charCode) => {
    return ([
        9, 10, 11, 12, 13, 32, 133, 160, 5760, 8192, 8193, 8194, 8195, 8196,
        8197, 8198, 8199, 8200, 8201, 8202, 8232, 8233, 8239, 8287, 12288
    ].indexOf(charCode) !== -1);
}, isDigit = (charCode) => charCode >= 48 && charCode <= 57, isAsciiLeter = (charCode) => {
    return ((charCode >= 65 && charCode <= 90) || (charCode >= 97 && charCode <= 122));
};
const isIntersecop = new lr.ExternalTokenizer((input, stack) => {
    let { next } = input, before;
    if (!isSpace(next) &&
        ((before = input.peek(-1)) !== closeParen ||
            !isDigit(before) ||
            !isAsciiLeter(before) ||
            before !== backSlash ||
            before !== underscore ||
            before !== dot ||
            before !== questionMark ||
            before !== euroSign))
        return;
    for (;;) {
        next = input.advance();
        if (!isSpace(next))
            break;
    }
    if (next === openParen ||
        isAsciiLeter(next) ||
        before === backSlash ||
        before === underscore)
        return input.acceptToken(intersecop);
}, { contextual: true });

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = lr.LRParser.deserialize({
  version: 14,
  states: "+WO!^QQOOOOQP'#C_'#C_O!hQTO'#C_O%]QTO'#DTO%mQQO'#CeOOQO'#DZ'#DZO%tQWO'#DZOOQP'#C^'#C^O%|QQO'#C^OOQO'#Cl'#ClO'YQQO'#DRO'aQQO'#CqO%mQQO'#CqOOQO'#Cq'#CqO(YQQO'#CuOOQO'#DT'#DTOOQO'#DR'#DRQOQQOOO%mQQO'#DRO(aQQO,59PO(aQQO,59POOQP,59P,59PO)OQTO,58xO)YQQO,59PO)_QQO,59oO'nQQO'#CuOOQO,59u,59uOOQP,58x,58xO%mQQO,59zO%mQQO,59zO%mQQO,59zO%mQQO,59zO%mQQO,59zOOQO,59],59]O)fQQO'#CtO)pQQO'#CsO)xQQO,59]O)}QQO,59]OOQO'#Dl'#DlOOQO'#Cx'#CxO*_QQO'#CxO*dQQO'#CwO*oQQO'#CvO*wQQO,59aO%mQQO,5:YO*|QQO,59mOOQP1G.k1G.kO(aQQO'#CeO+TQTO1G.kO(aQQO'#CyO,eQQO,59QOOQP1G.d1G.dOOQO1G/Z1G/ZO-qQQO1G/fO-xQQO1G/fO/QQQO1G/fO/[QQO1G/fO/}QQO1G/fO'aQQO'#CzO0qQQO,59_OOQO1G.w1G.wOOQO,59d,59dO'nQQO'#C{O0yQQO,59cO'nQQO'#C|O1UQQO,59bOOQO1G.{1G.{O1^QQO1G/tO1eQTO,58xO1vQTO,59eOOQO-E6w-E6wOOQO,59f,59fOOQO-E6x-E6xOOQO,59g,59gOOQO-E6y-E6yOOQO,59h,59hOOQO-E6z-E6zOOQO7+%`7+%`",
  stateData: "2j~OtOS~OSPOTPOUPOVPOWQOZTO[UO^TOaXObXOcXOdXOfZOySO!O[O!P[O!Q[O~OvbO!_^O~PVOS}XT}XU}XV}XW}XqRXrRXvRXxRX|RX!ORX!PRX!RRX!TRX!URX!VRX!WRX!XRX!YRX!ZRX![RX!]RXzRX{RX!^RX~OrdOxcO|eOvwX!OwX!PwX!RwX!TwX!UwX!VwX!WwX!XwX!YwX!ZwX![wX!]wX~OqwXzwX{wX!^wX~P$XO!_iO~PVO]jO_jO~OSPOTPOUPOVPOWPO~OvpO!OnO!PnO!RqO!TlO!UmO!VmO!WoO!XpO!YpO!ZpO![pO!]pO~OquX~P&_O!_iOzhP{hP~PVOWwOaXObXOcXOdXO!OvO!PvO!QvO~Ov|O~P'nOSPOTPOUPOVPOWQOZTO[UO^TOy!PO~Oz!RO{!TO~P$XO{!OO~O{!UO~P&_OzhX{hX~P&_Oz![O{gX~O{!^O~Oqea{eazea!^ea~P&_Oa!_O~Oz!`O!^kX!akX~O!a!bO!^jX~O!^!dO~Oqua~P&_OxcOqXirXivXi|Xi!OXi!PXi!RXi!TXi!UXi!VXi!WXi!XXi!YXi!ZXi![Xi!]XizXi{Xi!^Xi~Oz!RO{Ya~O!RqOq!Siv!Si!O!Si!P!Si!U!Si!V!Si!W!Si!X!Si!Y!Si!Z!Si![!Si!]!Si{!Siz!Si!^!Si~O!T!Si~P,mO!TlO~P,mO!RqO!TlO!UmO!VmOq!Siv!Si!W!Si!X!Si!Y!Si!Z!Si![!Si!]!Si{!Siz!Si!^!Si~O!O!Si!P!Si~P.PO!OnO!PnO~P.PO!OnO!PnO!RqO!TlO!UmO!VmO!WoO~Oq!Siv!Si!X!Si!Y!Si!Z!Si![!Si!]!Si{!Siz!Si!^!Si~P/fOz![O{ga~Oz!`O!^ka!aka~O!a!bO!^ja~O!^!oO~P&_OrdOxcOz!RO{!TO|eO~OrdOxcO|eOzma{ma~OV_]^bZafUScT!Q!Otf~",
  goto: "'j!cPP!d#QPPPPP#g#yPPPPP#}PPPP$cP$q$t$c$z%O%V%_%f%l%rPPPP%xP%{PPPPP&oPPPP'RPPPPPPPPPPP'aP'gfROZ[blmnop|![QfSQ!OcQ!QdQ!f!PR!g!RpVOSZ[bcdlmnop|!P!R![RkWqVOSZ[bcdlmnop|!P!R![TgS!Ph_OSZ[blmnop|![Xw^i!`!bi_OSZ[blmnop|![RtZQsZR!i![T{^iSz^iR!m!bUy^i!bR!k!`S!Sf!fR!h!SQ!]sR!j!]Q!ayR!l!aQ!czR!n!cRaOQYOQhSSrZ![Qu[Q}bQ!VlQ!WmQ!XnQ!YoQ!ZpR!e|qWOSZ[bcdlmnop|!P!R![i]OSZ[blmnop|![Xx^i!`!bR`O",
  nodeNames: "⚠ Program Reference ReferenceItem CellToken NameToken VerticalRangeToken HorizontalRangeToken RefErrorToken ReferenceFunctionCall Union SheetToken QuoteS SheetQuotedToken MultipleSheetsToken MultipleSheetsQuotedToken Constant NumberToken TextToken BoolToken ErrorToken FunctionCall Function Arguments Argument ConstantArray ArrayColumns ArrayRows ArrayConstant",
  maxTerm: 64,
  skippedNodes: [0],
  repeatNodeCount: 4,
  tokenData: "$/V~R}OX$OXY/eYZ/eZ]$O]^/e^p$Opq1eqr$Ors2rstHqtu!:wuv#%tvw#&lwx#'dxy#'lyz#(dz{#)[{|#)a|}#+Q}!O#+x!O!P#,p!P!Q#0O!Q![#0T![!]#1t!]!^#1y!^!_#2q!_!`#5_!`!a#6V!b!c#7{!c!h#9l!h!i#HY!i!v#9l!v!w$%p!w!}#9l#O#P#>v#Q#R$,o#R#S#<m#S#T$O#T#o#9l#o#p$-g#p#q$O#q#r$._#r;'S$O;'S;=`/_<%lO$O~$RhOp$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$OS%pZOw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mS&fQqr&lwx%mS&qO]SS&tYOw'dwx(kxz'd{!P'd!Q!['d!]!a'd!b!}'d#Q;'S'd;'S;=`(e<%lO'dS'gYOw'dwx(Vxz'd{!P'd!Q!['d!]!a'd!b!}'d#Q;'S'd;'S;=`(e<%lO'dS(YQqr(`wx'dS(eO_SS(hP;=`<%l'dS(nPwx'dS(tP;=`<%l%m~(|hZ~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~*kfOp,Ppq'dqs,Pst'dtu,Puw'dwx(kxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~,SgOp,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~-pg^~Op,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~/[P;=`<%l,P~/bP;=`<%l$O~/jmt~OX$OXY/eYZ/eZ]$O]^/e^p$Opq1eqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~1jbt~OX%mXY1eYZ1eZ]%m]^1e^p%mpq1eqw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~2ulOp2rpq4mqr=hrs?est4mtu2ruw4mwx6sxz4mz{7`{|2r|!O4m!O!P2r!P!Q7`!Q![2r![!]AU!]!a4m!a!b7`!b!}2r!}#Q7`#Q#R4m#R#o2r#o#p4m#p#q2r#q#r4m#r;'S2r;'S;=`Hk<%lO2r~4paOr4mrs5usw4mwx6sxz4mz{7`{!P4m!P!Q7`!Q![4m![!]8f!]!a4m!a!b7`!b!}4m!}#Q7`#Q;'S4m;'S;=`=b<%lO4m~5z]b~Or%mrs4msw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~6vWOq7`qr8Qrs7rsw7`wx4mx;'S7`;'S;=`7z<%lO7`~7cTOr7`rs7rs;'S7`;'S;=`7z<%lO7`~7wPb~rs7`~7}P;=`<%l7`~8VT]SOr7`rs7rs;'S7`;'S;=`7z<%lO7`~8iaOr9nrs:vsw9nwx<xxz9nz{7`{!P9n!P!Q7`!Q![9n![!]7`!]!a9n!a!b7`!b!}9n!}#Q7`#Q;'S9n;'S;=`<r<%lO9n~9qaOr9nrs:vsw9nwx;qxz9nz{7`{!P9n!P!Q7`!Q![9n![!]7`!]!a9n!a!b7`!b!}9n!}#Q7`#Q;'S9n;'S;=`<r<%lO9n~:{[b~Or'drs9nsw'dwx(Vxz'd{!P'd!Q!['d!]!a'd!b!}'d#Q;'S'd;'S;=`(e<%lO'd~;tWOq7`qr<^rs7rsw7`wx9nx;'S7`;'S;=`7z<%lO7`~<cT_SOr7`rs7rs;'S7`;'S;=`7z<%lO7`~<uP;=`<%l9n~<{VOr7`rs7rsw7`wx9nx;'S7`;'S;=`7z<%lO7`~=eP;=`<%l4m~=mlZ~Op2rpq4mqr=hrs?est4mtu2ruw4mwx6sxz4mz{7`{|2r|!O4m!O!P2r!P!Q7`!Q![2r![!]AU!]!a4m!a!b7`!b!}2r!}#Q7`#Q#R4m#R#o2r#o#p4m#p#q2r#q#r4m#r;'S2r;'S;=`Hk<%lO2r~?jhb~Op$Opq%mqr(wrs2rst%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~AXlOpCPpq9nqrCPrsFwst9ntuCPuw9nwx<xxz9nz{7`{|CP|!O9n!O!PCP!P!Q7`!Q![CP![!]7`!]!a9n!a!b7`!b!}CP!}#Q7`#Q#R9n#R#oCP#o#p9n#p#qCP#q#r9n#r;'SCP;'S;=`He<%lOCP~CSlOpCPpq9nqrDzrsFwst9ntuCPuw9nwx;qxz9nz{7`{|CP|!O9n!O!PCP!P!Q7`!Q![CP![!]7`!]!a9n!a!b7`!b!}CP!}#Q7`#Q#R9n#R#oCP#o#p9n#p#qCP#q#r9n#r;'SCP;'S;=`He<%lOCP~EPl^~OpCPpq9nqrDzrsFwst9ntuCPuw9nwx;qxz9nz{7`{|CP|!O9n!O!PCP!P!Q7`!Q![CP![!]7`!]!a9n!a!b7`!b!}CP!}#Q7`#Q#R9n#R#oCP#o#p9n#p#qCP#q#r9n#r;'SCP;'S;=`He<%lOCP~F|gb~Op,Ppq'dqr-krsCPst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~HhP;=`<%lCP~HnP;=`<%l2rVHvf|QOw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!f%m!f!gJ[!g!i%m!i!jM^!j!p%m!p!q!*W!q!t%m!t!u!0y!u!v!4e!v!x%m!x!y!7X!y!}%m#Q;'S%m;'S;=`(q<%lO%mTJ_]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!k%m!k!lKW!l!}%m#Q;'S%m;'S;=`(q<%lO%mTKZ]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!x%m!x!yLS!y!}%m#Q;'S%m;'S;=`(q<%lO%mTLV[Ow%mwx&cxz%m{!P%m!P!QL{!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mPMOP!Q!RMRPMUPqrMXPM^OdPTMa]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!g%m!g!hNY!h!}%m#Q;'S%m;'S;=`(q<%lO%mTN]]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!v%m!v!w! U!w!}%m#Q;'S%m;'S;=`(q<%lO%mT! X]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!v%m!v!w!!Q!w!}%m#Q;'S%m;'S;=`(q<%lO%mT!!T]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!k%m!k!l!!|!l!}%m#Q;'S%m;'S;=`(q<%lO%mT!#P]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!p%m!p!q!#x!q!}%m#Q;'S%m;'S;=`(q<%lO%mT!#{]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!i%m!i!j!$t!j!}%m#Q;'S%m;'S;=`(q<%lO%mT!$w]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q#R%m#R#S!%p#S;'S%m;'S;=`(q<%lO%mT!%s]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!f%m!f!g!&l!g!}%m#Q;'S%m;'S;=`(q<%lO%mT!&o]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!c%m!c!d!'h!d!}%m#Q;'S%m;'S;=`(q<%lO%mT!'k]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!v%m!v!w!(d!w!}%m#Q;'S%m;'S;=`(q<%lO%mT!(g]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!c%m!c!d!)`!d!}%m#Q;'S%m;'S;=`(q<%lO%mT!)eZdPOw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mT!*Z`Ow%mwx&cxz%m{!P%m!P!Q!+]!Q![%m![!]&q!]!a%m!b!c%m!c!d!+c!d!w%m!w!x!.S!x!}%m#Q;'S%m;'S;=`(q<%lO%mP!+`P!c!dMXT!+f]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!o%m!o!p!,_!p!}%m#Q;'S%m;'S;=`(q<%lO%mT!,b]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!g%m!g!h!-Z!h!}%m#Q;'S%m;'S;=`(q<%lO%mT!-^[Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!a!bMX!b!}%m#Q;'S%m;'S;=`(q<%lO%mT!.V^Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!n%m!n!o!/R!o!p!/}!p!}%m#Q;'S%m;'S;=`(q<%lO%mT!/U]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!n%m!n!o!/}!o!}%m#Q;'S%m;'S;=`(q<%lO%mT!0Q]Oq%mqr!)`rw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV!0|]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!g%m!g!h!1u!h!}%m#Q;'S%m;'S;=`(q<%lO%mV!1x]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!h%m!h!i!2q!i!}%m#Q;'S%m;'S;=`(q<%lO%mV!2t]Oq%mqr!3mrw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV!3rZWROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mT!4h]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!r%m!r!s!5a!s!}%m#Q;'S%m;'S;=`(q<%lO%mT!5d]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!k%m!k!l!6]!l!}%m#Q;'S%m;'S;=`(q<%lO%mT!6`]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!n%m!n!o!/R!o!}%m#Q;'S%m;'S;=`(q<%lO%mT!7[]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!c%m!c!d!8T!d!}%m#Q;'S%m;'S;=`(q<%lO%mT!8W]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!n%m!n!o!9P!o!}%m#Q;'S%m;'S;=`(q<%lO%mT!9S]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!w%m!w!x!9{!x!}%m#Q;'S%m;'S;=`(q<%lO%mT!:O]Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!g%m!g!h!/}!h!}%m#Q;'S%m;'S;=`(q<%lO%m~!:zjOp$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!<l![!]*h!]!a%m!b!c$O!c!}!Bz#Q#R%m#R#T$O#T#o!Bz#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~!<ohOp$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!<l![!]!>Z!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~!>^fOp,Ppq'dqs,Pst'dtu!?ruw'dwx(kxz'd{|,P|!O'd!O!P,P!Q![!A^!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!?ugOp,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![!A^!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!AcgV~Op,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![!A^!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!B}jOp$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!F^![!]!G}!]!a%m!b!c$O!c!}#!b#Q#R%m#R#T$O#T#o#!b#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~!DrhOp$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!F^![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~!FchS~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!F^![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~!HQhOp,Ppq'dqs,Pst'dtu!Iluw'dwx(kxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!c,P!c!}!K^#Q#R'd#R#T,P#T#o!K^#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!IoiOp,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!c,P!c!}!K^#Q#R'd#R#T,P#T#o!K^#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!KciU~Op,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!c,P!c!}!MQ#Q#R'd#R#T,P#T#o!MQ#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!MViU~Op,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!c,P!c!}!Nt#Q#R'd#R#T,P#T#o!Nt#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~!NygU~Op,Ppq'dqr-krs,Pst'dtu,Puw'dwx(Vxz'd{|,P|!O'd!O!P,P!Q![,P!]!a'd!b!},P#Q#R'd#R#o,P#o#p'd#p#q,P#q#r'd#r;'S,P;'S;=`/X<%lO,P~#!ejOp$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!F^![!]!G}!]!a%m!b!c$O!c!}#$V#Q#R%m#R#T$O#T#o#$V#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~#$YhOp$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![!F^![!]!G}!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$OV#%yZ!RROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#&qZ!WROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mT#'iP[Pwx%mT#'qZyPOw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#(iZ{ROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~#)aO!U~~#)fh!O~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$OV#+VZzROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#+}Z!PROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~#,shOp$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![#._![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~#.dha~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![#._![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~#0TO!V~~#0Yha~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P#._!Q![#0T![!]!>Z!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~#1yOx~T#2OZ!aPOw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#2v]!YROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!_%m!_!`#3o!`!a#4g!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#3tZ!]ROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#4lZ!ZROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#5dZvROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#6[]!XROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!_%m!_!`#7T!`!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV#7YZ![ROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~#8Qh!Q~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P$O!Q![$O![!]*h!]!a%m!b!}$O#Q#R%m#R#o$O#o#p%m#p#q$O#q#r%m#r;'S$O;'S;=`/_<%lO$O~#9qpT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!}#Cv#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#Cv#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#;zZf~Ow%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m~#<rpT~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#<m![!]*h!]!a%m!a!b#>v!b!c$O!c!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#>{WT~!O!P#>v!Q![#>v!a!b#>v!c!}#>v#O#P#>v#R#S#>v#T#o#>v$Lv$Lw#>v~#?joT~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxz%m{|$O|!O%m!O!P#?e!Q![#?e![!]*h!]!a%m!a!b#>v!b!c$O!c!}#?e#O#P#>v#Q#R%m#R#S#?e#S#T$O#T#o#?e#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#ArpS~T~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]*h!]!a%m!a!b#>v!b!c$O!c!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#C{pT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!}#FP#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#FP#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#FUpT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#H_qT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!d#Jf!d!}#Cv#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#Cv#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#JkrT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!n#FP!n!o#Lu!o!}#FP#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#FP#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~#LzrT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!u#<m!u!v$ U!v!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~$ ZrT~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#<m![!]*h!]!a%m!a!b#>v!b!c$O!c!g#<m!g!h$#e!h!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~$#lpc~T~Op$Opq%mqr(wrs$Ost%mtu$Ouw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#<m![!]*h!]!a%m!a!b#>v!b!c$O!c!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~$%urT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!t#Cv!t!u$(P!u!}#Cv#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#Cv#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~$(UrT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!w#FP!w!x$*`!x!}#FP#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#FP#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$O~$*erT~Op$Opq%mqr(wrs$Ost%mtu!Douw%mwx&cxy#;uyz%m{|$O|!O%m!O!P#<m!Q![#Ak![!]!G}!]!a%m!a!b#>v!b!c$O!c!g#<m!g!h$#e!h!}#<m#O#P#>v#Q#R%m#R#S#<m#S#T$O#T#o#<m#o#p%m#p#q$O#q#r%m#r$Lv$O$Lv$Lw#?e$Lw;'S$O;'S;=`/_<%lO$OV$,tZ!TROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mT$-lZ!_POw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%mV$.dZ!^ROw%mwx&cxz%m{!P%m!Q![%m![!]&q!]!a%m!b!}%m#Q;'S%m;'S;=`(q<%lO%m",
  tokenizers: [isIntersecop, 0, 1, 2],
  topRules: {"Program":[0,1]},
  tokenPrec: 791
});

const spreadsheetLanguage = language.LRLanguage.define({
    parser: parser.configure({
        props: [
            language.indentNodeProp.add({
                Application: language.delimitedIndent({ closing: ')', align: false })
            }),
            language.foldNodeProp.add({
                Application: language.foldInside
            }),
            highlight.styleTags({
                Identifier: highlight.tags.variableName,
                Boolean: highlight.tags.bool,
                String: highlight.tags.string,
                LineComment: highlight.tags.lineComment,
                '( )': highlight.tags.paren
            })
        ]
    }),
    languageData: {
        commentTokens: { line: ';' }
    }
});
function spreadsheet() {
    return new language.LanguageSupport(spreadsheetLanguage);
}

exports.spreadsheet = spreadsheet;
exports.spreadsheetLanguage = spreadsheetLanguage;
